
/*
** (c) 2003 Herbert Poetzl
**
** V0.01	test for syscall
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <syscall.h>
#include <asm/unistd.h>
#include <unistd.h>
#include <sched.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mount.h>

 
#include "vswitch.h"
#undef	ENOTSUP
#include <linux/vserver/switch.h>
#include <linux/vserver/context.h>
#include <linux/vserver/sched.h>


static	char	err_flag = 0;

static	char	opt_vers = 0;
static	char	opt_sched = 0;

static	char *	cmd_name = NULL;

static	int 	num_ctx = 0;

static	struct 	vcmd_set_sched_v2 data = {
			SCHED_KEEP,
			SCHED_KEEP,
			SCHED_KEEP,
			SCHED_KEEP,
			SCHED_KEEP,
			-1 }; 


#define OPTIONS "+hx:I:M:R:S:T:V"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;


        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-x <num>  context id\n"
                    "-I <num>  set fill interval to <num>\n"
                    "-M <num>  set unhold minumum to <num>\n"
                    "-R <num>  set fill rate to <num>\n"
                    "-S <num>  set bucket size to <num>\n"
                    "-T <num>  set token number to <num>\n"
                    "-V        verify interface version\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case 'x':
                num_ctx = atol(optarg);
                opt_sched = 1;
                break;
            case 'I':
                data.interval = atol(optarg);
                opt_sched = 1;
                break;
            case 'M':
                data.tokens_min = atol(optarg);
                opt_sched = 1;
                break;
            case 'R':
                data.fill_rate = atol(optarg);
                opt_sched = 1;
                break;
            case 'S':
                data.tokens_max = atol(optarg);
                opt_sched = 1;
                break;
            case 'T':
                data.tokens = atol(optarg);
                opt_sched = 1;
                break;
            case 'V':
                opt_vers = 1;
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "]\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

	if (opt_vers) {
	    r = vserver(VCMD_get_version, 0, NULL);
	    if (r<0)
	    	perror("vc_get_version");
    	    else 
	    	printf("version: %04x:%04x\n", 
		    (r>>16)&0xFFFF, r&0xFFFF);
	}

	if (opt_sched) {
	    r = vserver(VCMD_set_sched, num_ctx, &data);
	    if (r)
	    	perror("vc_set_sched");
	}
	
	exit((err_flag)?1:0);
}

